
-- ========================
--  APEX Connect 2024
--  Gunther Pipprr https://www.pipperr.de/dokuwiki/doku.php
--
-- =========================

set echo ON

ALTER SESSION SET  PLSQL_OPTIMIZE_LEVEL=2;
ALTER SESSION SET  PLSQL_CODE_TYPE='INTERPRETED';
ALTER SESSION SET PLSQL_WARNINGS='ENABLE:ALL';

ACCEPT step1 

SET serveroutput ON

create or replace procedure numberCheck
as
  
  FUNCTION check_numbers (p_1 IN varchar2 )
    RETURN NUMBER 
  AS
   v_num_check number;
  BEGIN
    begin 
	 v_num_check := to_number(p_1); --- so wre es richtiger ! TO_NUMBER(p_1 DEFAULT null ON CONVERSION ERROR)
     v_num_check:=1;
	exception 
     when OTHERS 
		then
		v_num_check:=null;
	end;	
    RETURN v_num_check;
  END check_numbers;

BEGIN
  
   DBMS_OUTPUT.put_line('Prfe auf Nummer 0  -- wenn nummer dann 1  : ' || check_numbers('0'));
   
   DBMS_OUTPUT.put_line('Prfe auf Nummer ABC - wenn nummer dann 1  : ' || check_numbers('ABC'));
      
  
END;
/

show errors

ACCEPT step2 

begin
 numberCheck;
end;
/

ACCEPT step3 
 


select plsql_optimize_level
 from user_plsql_object_settings 
where name =  upper('numberCheck')
/

------------------------------------------
ACCEPT step4 


ALTER SESSION SET  PLSQL_OPTIMIZE_LEVEL=3;

alter procedure numberCheck compile;

show errors

ACCEPT step5 


begin
 numberCheck;
end;
/


ACCEPT step6  

select  plsql_optimize_level
  from user_plsql_object_settings 
where name =  upper('numberCheck')
/


--------------------------------------