-- ========================
--  APEX Connect 2024
--  Gunther Pippèrr https://www.pipperr.de/dokuwiki/doku.php
--
-- =========================

set echo ON

-- 19c


with 
  function  getKundenNummer_with(p_kde_id number) 
   return varchar2 
  as 
  begin
    return  case when p_kde_id < 1000 
          then lpad(to_char(p_kde_id),4,'0') 
           else to_char(p_kde_id) 
            end;
  end;
select * from EMPLOYEES where  getKundenNummer_with(EMPLOYEE_ID) = '0106';  
/  
  
  
ACCEPT step1 
  
  
--ab 21c-

create or replace function getKundenNummer_SM(p_kde_id number) 
return varchar2 
SQL_MACRO(SCALAR) 
as
begin
  return('case when p_kde_id < 1000 
          then lpad(to_char(p_kde_id),4,''0'') 
          else to_char(p_kde_id) 
           end'
  );
end;
/ 

show errors


ACCEPT step1 

SET SERVEROUTPUT ON 

DECLARE
  v_full_sql CLOB;
BEGIN
 
  DBMS_UTILITY.expand_sql_text (
    input_sql_text  => q'[select getKundenNummer_SM(EMPLOYEE_ID) as norm_id  from EMPLOYEES]',
    output_sql_text => v_full_sql 
  );
 
  DBMS_OUTPUT.put_line(v_full_sql );
 
END;
/

ACCEPT step1 

set autotrace on

select getKundenNummer_SM(EMPLOYEE_ID) as norm_id  from EMPLOYEES;

ACCEPT step1 

set autotrace on


select * from EMPLOYEES where  getKundenNummer_SM(EMPLOYEE_ID) = '0106';

ACCEPT step1 